import "./style.css";
import { reactive as w, ref as D, watchEffect as j, onActivated as B, nextTick as x, onBeforeUnmount as A, resolveComponent as g, openBlock as T, createElementBlock as F, createElementVNode as l, createVNode as f, withCtx as P, withDirectives as W, vShow as O } from "vue";
import { Button as U } from "@opentiny/vue";
import { VueMonaco as V, CloseIcon as H, LinkButton as J } from "@opentiny/tiny-engine-common";
import { useCanvas as v, useNotify as y, useModal as E, useHelp as I } from "@opentiny/tiny-engine-meta-register";
import { initCompletion as z } from "@opentiny/tiny-engine-common/js/completion";
import { lint as R, initLinter as Y } from "@opentiny/tiny-engine-common/js/linter";
import { insertName as q, string2Ast as b, formatString as G, ast2String as K } from "@opentiny/tiny-engine-common/js/ast";
import { constants as Q } from "@opentiny/tiny-engine-utils";
import { isFunction as X } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: Z } = Q, r = w({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null
}), a = D(null);
let h = null;
const _ = () => {
  var o, n;
  const e = ((n = (o = v().canvasApi.value).getSchema) == null ? void 0 : n.call(o)) || {};
  return e.methods = (e == null ? void 0 : e.methods) || {}, e.methods;
}, $ = () => v().pageState.pageSchema && Object.keys(_()) || [], M = () => {
  const o = Object.entries(_()).map(([n, t]) => q(n, t.value)).join(`
`);
  try {
    h = b(o);
  } catch (n) {
    y({
      type: "error",
      message: `代码静态检查有错误：${n}`
    });
  }
  return o;
}, tt = (e) => {
  if (r.isChanged = e !== r.script, !a.value)
    return;
  const o = a.value.getEditor().getModel();
  R(o, r.linterWorker);
}, k = ({ name: e, content: o }) => {
  if (!e)
    return;
  const n = _();
  n[e] || (n[e] = {
    type: Z.JSFunction,
    value: ""
  }), n[e].value = o;
}, L = () => {
  const { message: e } = E();
  if (!r.isChanged)
    return !1;
  if (r.hasError)
    return e({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const o = a.value.getEditor().getValue(), n = b(o);
  return v().canvasApi.value.getSchema().methods = {}, n.program.body.forEach((t, s) => {
    var d, u;
    const i = (d = t == null ? void 0 : t.id) == null ? void 0 : d.name;
    (u = n.program.body[s + 1]) != null && u.leadingComments && t.trailingComments === n.program.body[s + 1].leadingComments && delete t.trailingComments;
    const m = G(K(t).trim(), "javascript");
    k({ name: i, content: m });
  }), v().setSaved(!1), r.isChanged = !1, y({
    type: "success",
    message: "保存成功！"
  }), !0;
}, et = (e) => (o) => {
  const { confirm: n } = E(), t = X(o) ? o : () => e("close");
  if (!r.isChanged) {
    t(!0);
    return;
  }
  n({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      t(L());
    },
    cancel() {
      t(!0);
    }
  });
}, ot = () => {
  if (!r.editorSelection || !a.value)
    return;
  const e = a.value.getEditor();
  e.setSelection(r.editorSelection), e.focus();
  const o = e.getTopForLineNumber(r.editorSelection.startLineNumber - 1);
  e.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: o
    },
    0
  );
}, nt = (e) => {
  var t;
  if (!e)
    return;
  const o = h == null ? void 0 : h.program.body.filter((s) => {
    var i;
    return e === ((i = s == null ? void 0 : s.id) == null ? void 0 : i.name);
  });
  if (o.length === 0)
    return;
  const n = (t = o[0]) == null ? void 0 : t.loc;
  n && (r.editorSelection = {
    startColumn: n.start.column,
    startLineNumber: n.start.line,
    endColumn: n.end.column + 1,
    endLineNumber: n.end.line
  }), r.editorSelection && ot();
}, st = ({ emit: e }) => (j(() => {
  r.script = M();
}), B(() => {
  x(() => {
    var o;
    r.script = M(), (o = a.value) == null || o.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: r,
  monaco: a,
  change: tt,
  saveMethods: L,
  close: et(e)
}), rt = (e, o) => {
  const n = e.__vccOpts || e;
  for (const [t, s] of o)
    n[t] = s;
  return n;
}, it = {
  saveMethod: k,
  highlightMethod: nt,
  getMethodNameList: $,
  getMethods: _
}, ct = {
  components: {
    MonacoEditor: V,
    TinyButton: U,
    CloseIcon: H,
    LinkButton: J
  },
  emits: ["close"],
  setup(e, { emit: o }) {
    const n = I().getDocsUrl("script"), { state: t, monaco: s, change: i, close: m, saveMethods: d } = st({ emit: o }), u = {
      language: "javascript",
      minimap: {
        enabled: !1
      },
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, C = (p) => {
      var c;
      s.value && (t.completionProvider = z(s.value.getMonaco(), (c = s.value.getEditor()) == null ? void 0 : c.getModel()), t.linterWorker = Y(p, s.value.getMonaco(), t));
    };
    return A(() => {
      var p, c, S;
      (p = t.completionProvider) == null || p.forEach((N) => {
        N.dispose();
      }), (S = (c = t.linterWorker) == null ? void 0 : c.terminate) == null || S.call(c);
    }), {
      state: t,
      monaco: s,
      options: u,
      close: m,
      change: i,
      saveMethods: d,
      editorDidMount: C,
      docsUrl: n
    };
  }
}, lt = { class: "plugin-page-js-container" }, at = { class: "code-edit-head" }, dt = { class: "head-left" }, ut = { class: "head-right" }, mt = { class: "dots" }, pt = { class: "code-edit-content" };
function gt(e, o, n, t, s, i) {
  const m = g("link-button"), d = g("tiny-button"), u = g("close-icon"), C = g("monaco-editor");
  return T(), F("div", lt, [
    l("div", at, [
      l("div", dt, [
        o[0] || (o[0] = l("span", { class: "title" }, "页面 JS", -1)),
        f(m, { href: t.docsUrl }, null, 8, ["href"])
      ]),
      l("div", ut, [
        f(d, {
          type: "primary",
          class: "save-btn",
          onClick: t.saveMethods
        }, {
          default: P(() => [
            o[1] || (o[1] = l("span", null, "保存", -1)),
            W(l("span", mt, null, 512), [
              [O, t.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        f(u, { onClose: t.close }, null, 8, ["onClose"])
      ])
    ]),
    l("div", pt, [
      f(C, {
        ref: "monaco",
        value: t.state.script,
        options: t.options,
        onChange: t.change,
        onEditorDidMount: t.editorDidMount
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount"])
    ])
  ]);
}
const ft = /* @__PURE__ */ rt(ct, [["render", gt], ["__scopeId", "data-v-11457b66"]]), ht = {
  id: "engine.plugins.pagecontroller",
  title: "页面 JS",
  type: "plugins",
  icon: "plugin-icon-js",
  align: "top",
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
}, Nt = {
  ...ht,
  apis: it,
  entry: ft
};
export {
  Nt as default
};
